var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
} 

function initialiseGUI(){
    imgPC=document.getElementById("pc3");
    redVal=new CanvasInput({
        canvas: document.getElementById("visualisation"),
        x: 60,
        y: sldrRedTop-20,
        fontSize: 14,
        fontFamily: "Arial",
        fontColor: "#ff0000",
        fontWeight: "bold",
        width: 35,
        height:14,
        padding: 8,
        borderWidth: 1,
        borderColor: "#0f0f0f",
        borderRadius: 3,
        boxShadow: "1px 1px 0px #fff",
        innerShadow: "0px 0px 5px rgba(0, 0, 0, 0.5)",
        placeHolder: "...",
        onkeyup: (function() {handleTextBoxEntry(redVal);} )
      });
    greenVal=new CanvasInput({
        canvas: document.getElementById("visualisation"),
        x: 60,
        y: sldrGreenTop-20,
        fontSize: 14,
        fontFamily: "Arial",
        fontColor: "#00ff00",
        fontWeight: "bold",
        width: 35,
        height:14,
        padding: 8,
        borderWidth: 1,
        borderColor: "#0f0f0f",
        borderRadius: 3,
        boxShadow: "1px 1px 0px #fff",
        innerShadow: "0px 0px 5px rgba(0, 0, 0, 0.5)",
        placeHolder: "...",
        onkeyup: (function() {handleTextBoxEntry(greenVal);} )
      });
    blueVal=new CanvasInput({
        canvas: document.getElementById("visualisation"),
        x: 60,
        y: sldrBlueTop-20,
        fontSize: 14,
        fontFamily: "Arial",
        fontColor: "#0000ff",
        fontWeight: "bold",
        width: 35,
        height:14,
        padding: 8,
        borderWidth: 1,
        borderColor: "#0f0f0f",
        borderRadius: 3,
        boxShadow: "1px 1px 0px #fff",
        innerShadow: "0px 0px 5px rgba(0, 0, 0, 0.5)",
        placeHolder: "...",
        onkeyup: (function() {handleTextBoxEntry(blueVal);} )
      });
    
    sldrRed=new slider(sldrRedLeft,sldrRedTop,sldrRedWidth,sldrRedHeight,sldrRedMin,sldrRedMax,sldrRedMin,sldrRedScaleVisible,sldrRedScaleDigital,[],sldrRedViewComparative,cntx);
    sldrGreen=new slider(sldrGreenLeft,sldrGreenTop,sldrGreenWidth,sldrGreenHeight,sldrGreenMin,sldrGreenMax,sldrGreenMin,sldrGreenScaleVisible,sldrGreenScaleDigital,[],sldrGreenViewComparative,cntx);
    sldrBlue=new slider(sldrBlueLeft,sldrBlueTop,sldrBlueWidth,sldrBlueHeight,sldrBlueMin,sldrBlueMax,sldrBlueMin,sldrBlueScaleVisible,sldrBlueScaleDigital,[],sldrBlueViewComparative,cntx);
    
    redVal.value(sldrRed.markerValue);
    greenVal.value(sldrGreen.markerValue);
    blueVal.value(sldrBlue.markerValue);

    PartialColorLEFT=sldrRed.left+sldrRed.width+2*BORDER;
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgPC=document.getElementById("pc3");
    PCLeft=550;
    PCTop=TopPanelHeight+6*BORDER;
    ScreenX=PCLeft+29;
    ScreenY=PCTop+18;
    txtRedTOP=TopPanelHeight+4*BORDER;
    txtGreenTOP=txtRedTOP+ScreenHEIGHT+2*BORDER;
    txtBlueTOP=txtGreenTOP+ScreenHEIGHT+2*BORDER;
}

function drawBasicScreen(){
    //Φόντα οθόνης
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //ΠΛΑΙΣΙΑ
    cntx.fillStyle=PanelColor;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.fillRect(0,0,width,TopPanelHeight);
    cntx.rect(0,0,width,TopPanelHeight);
    //κάτω πλαίσιο
    cntx.fillRect(0,BottomPanelTop,width,BottomPanelHeight);
    cntx.rect(0,BottomPanelTop,width,BottomPanelHeight);
    cntx.stroke();
    //Εικόνες
    drawLogoImage();
    cntx.drawImage(imgPC,PCLeft,PCTop);
    //Τίτλος εφαρμογής
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cnvsWrite(LetterColor,16,"Arial",-1,BottomPanelTop+25,"1. Τροποποίησε τα βασικά χρώματα είτε πληκτρολογώντας τιμή [0 , 255], ή αλλάζοντας τη μπάρα κύλισης.");
    cnvsWrite(LetterColor,16,"Arial",-1,BottomPanelTop+50,"2. Σύρε τα βασικά χρώματα στην οθόνη του PC.");
    //Μηνύματα
    cnvsWrite(LetterColor,fontSize+5,"Arial",40,BottomPanelTop-25,errMsg);


    redVal.render();
    greenVal.render();
    blueVal.render();
    sldrRed.render();
    sldrGreen.render();
    sldrBlue.render();
    DrawColors();
    DrawMovingColor();
    drawGreySwitch();
}

function drawLogoImage(){
    cntx.drawImage(imgLogo,logoLeft,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
    if(sldrRed.markerHover(mx,my)){
        sldrRed.markerGrabbed=true;
        sldrRed.mouseXOffset=mx-sldrRed.markerLeft;
    }
    else if(sldrGreen.markerHover(mx,my)){
        sldrGreen.markerGrabbed=true;
        sldrGreen.mouseXOffset=mx-sldrGreen.markerLeft;
    }
    else if(sldrBlue.markerHover(mx,my)){
        sldrBlue.markerGrabbed=true;
        sldrBlue.mouseXOffset=mx-sldrBlue.markerLeft;
    }
    else if(colorHovered!=-1){
        colorSlctd=colorHovered;
        dXColor=mx-PartialColorLEFT;
        switch(colorHovered){
            case 0:
                dYColor=my-txtRedTOP;
                break;
            case 1:
                dYColor=my-txtGreenTOP;
                break;
            case 2:
                dYColor=my-txtBlueTOP;
                break;
        }
    }
}

function handleMouseMove(){
    greySwitchHover=false;
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else {
        imgLogo=document.getElementById("Logo");
    }

    canvas.style.cursor="default";
    if(sldrRed.markerGrabbed){
        sldrRed.setMarkerPosition(mx-sldrRed.mouseXOffset);
        if(greyOn){
            defineGreyColor(sldrRed.markerValue,mx-sldrRed.mouseXOffset);
        }
        else{
            BorderRed=true;
            //sldrRed.setMarkerPosition(mx-sldrRed.mouseXOffset);
            redVal.value(sldrRed.markerValue);
            Red=sldrRed.markerValue;
        }
        canvas.style.cursor="pointer";
    }
    else if(sldrGreen.markerGrabbed){
        sldrGreen.setMarkerPosition(mx-sldrGreen.mouseXOffset);
        if(greyOn){
            defineGreyColor(sldrGreen.markerValue,mx-sldrGreen.mouseXOffset);
        }
        else{
            BorderGreen=true;
            //sldrGreen.setMarkerPosition(mx-sldrGreen.mouseXOffset);
            greenVal.value(sldrGreen.markerValue);
            Green=sldrGreen.markerValue;
        }
        canvas.style.cursor="pointer";
    }
    else if(sldrBlue.markerGrabbed){
        sldrBlue.setMarkerPosition(mx-sldrBlue.mouseXOffset);
        if(greyOn){
            defineGreyColor(sldrBlue.markerValue,mx-sldrBlue.mouseXOffset);
        }
        else{
            BorderBlue=true;
            //sldrBlue.setMarkerPosition(mx-sldrBlue.mouseXOffset);
            blueVal.value(sldrBlue.markerValue);
            Blue=sldrBlue.markerValue;
        }
        canvas.style.cursor="pointer";
    }
    else if(mx>=greySwitchLeft && mx<greySwitchLeft+switchSize && my>=greySwitchTop && my<greySwitchTop+switchSize){
        greySwitchHover=true;
    }
    else if(colorSlctd>-1){
        if (mx>=ScreenX && mx<ScreenX+ScreenWIDTH && my>=ScreenY && my<ScreenY+ScreenHEIGHT) {
            canvas.style.cursor="crosshair";
        }
        else {
            canvas.style.cursor="all-scroll";
        }
    }
    else{//μετακίνηση χωρίς πάτημα κουμπιού
        colorHovered=-1;
        if(mx>=PartialColorLEFT && mx<=PartialColorLEFT+ScreenWIDTH){
            if(my>=txtRedTOP && my<=txtRedTOP+ScreenHEIGHT && BorderRed){
                colorHovered=0;
            }
            else if(my>=txtGreenTOP && my<=txtGreenTOP+ScreenHEIGHT && BorderGreen){
                colorHovered=1;
            }
            else if(my>=txtBlueTOP && my<=txtBlueTOP+ScreenHEIGHT && BorderBlue){
                colorHovered=2;
            }
            if(colorHovered!=-1){
                canvas.style.cursor="pointer";
            }
        }
        else if(sldrRed.markerHover(mx,my) || sldrGreen.markerHover(mx,my) || sldrBlue.markerHover(mx,my)){
            canvas.style.cursor="pointer";
        }
    }

    drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if(greySwitchHover){
        greyOn=!greyOn;
    }
    if (colorSlctd>-1){
        if (mx>=ScreenX && mx<ScreenX+ScreenWIDTH && my>=ScreenY && my<ScreenY+ScreenHEIGHT){
            if(colorSlctd==0){
                ScreenRed=parseInt(Red);
                BorderRed=false;
            }
            else if(colorSlctd==1){
                ScreenGreen=parseInt(Green);
                BorderGreen=false;
            }
            else if(colorSlctd==2){
                ScreenBlue=parseInt(Blue);
                BorderBlue=false;
            }
            canvas.style.cursor="default";
        }
    }
    colorHovered=-1;
    colorSlctd=-1;
    mouseBtn=-1;
    sldrRed.markerGrabbed=false;
    sldrGreen.markerGrabbed=false;
    sldrBlue.markerGrabbed=false;
    drawBasicScreen();
}

function numberOK(No){
    var sum=0;
    var flag=No.length==0?false:true;
    var digit;
    if(flag){
        for(var i=0;i<No.length;i++){
            digit=No.charAt(i);
            if(digit<"0" || digit>"9"){
                flag=false;
            }
            else{
                sum=sum+parseInt(digit*Math.pow(10,parseInt(No.length-i-1)));
            }           
        }
    }
    return flag;
}

function textValueChanged(){
    txt=redVal.value();
    if (txt==""){
        cnvsWrite(LetterColor,fontSize+5,"Arial",40,430,"Πληκτρολόγησε έναν αριθμό μέσα στο λευκό πλαίσιο!");
    }
    else{
        if (txt.length>3) {
            txt=txt.substring(0,3); 
            redVal.value(txt);
            redVal.selectText([0,0]);
        }
        if (numberOK(txt)) {
            redVal.fontColor("#00f");
        }
        else{
            redVal.fontColor("#f00");
            cnvsWrite(LetterColor,fontSize+5,"Arial",40,430,"Καλύτερα χρησιμοποίησε μόνο αριθμητικά ψηφία!");
        }
    }
    
}

function defineGreyColor(newColor,newMarkerPosition){
    if(Red!=newColor){
        BorderRed=true;
    }
    if(Green!=newColor){
        BorderGreen=true;
    }
    if(Blue!=newColor){
        BorderBlue=true;
    }
    if(newMarkerPosition>-1){
        sldrRed.setMarkerPosition(newMarkerPosition);
        sldrGreen.setMarkerPosition(newMarkerPosition);
        sldrBlue.setMarkerPosition(newMarkerPosition);   
    }
    else{
        sldrRed.setMarkerValue(newColor);
        sldrGreen.setMarkerValue(newColor);
        sldrBlue.setMarkerValue(newColor);
    }

    redVal.value(newColor);
    greenVal.value(newColor);
    blueVal.value(newColor);
    Red=newColor;
    Green=newColor;
    Blue=newColor;
}

function DrawColors(){
    cntx.fillStyle="rgb("+sldrRed.markerValue+",0,0)";
    cntx.fillRect(PartialColorLEFT,txtRedTOP,ScreenWIDTH,ScreenHEIGHT);
    if(BorderRed){
        cntx.fillStyle="rgb(0,0,0)";
        cntx.rect(PartialColorLEFT-2,txtRedTOP-2,ScreenWIDTH+4,ScreenHEIGHT+4);
    }
    cntx.fillStyle="rgb(0,"+sldrGreen.markerValue+",0)";
    cntx.fillRect(PartialColorLEFT,txtGreenTOP,ScreenWIDTH,ScreenHEIGHT);
    if(BorderGreen){
        cntx.fillStyle="rgb(0,0,0)";
        cntx.rect(PartialColorLEFT-2,txtGreenTOP-2,ScreenWIDTH+4,ScreenHEIGHT+4);
    }
    cntx.fillStyle="rgb(0,0,"+sldrBlue.markerValue+")";
    cntx.fillRect(PartialColorLEFT,txtBlueTOP,ScreenWIDTH,ScreenHEIGHT);
    if(BorderBlue){
        cntx.fillStyle="rgb(0,0,0)";
        cntx.rect(PartialColorLEFT-2,txtBlueTOP-2,ScreenWIDTH+4,ScreenHEIGHT+4);
    }
    //Η επόμενη εντολή σχεδιάζει το βοηθητικό πλαίσιο του χρώματος αναφοράς
    cntx.stroke();
    DrawScreenColor();
}

function DrawMovingColor(){
    var drawOK;
    if(colorSlctd>-1){              
        var MovingX=mx-dXColor,MovingY=my-dYColor;              
        var DrawX,DrawY;            
        for(var i=0;i<ScreenWIDTH;i++){
            DrawX=MovingX+i;
            for(var j=0;j<ScreenHEIGHT;j++){
                DrawY=MovingY+j;
                drawOK=true;
                if(DrawX>=ScreenX && DrawX<ScreenX+ScreenWIDTH && DrawY>=ScreenY && DrawY<ScreenY+ScreenHEIGHT){                       
                    if(colorSlctd==0){
                        cntx.fillStyle="rgb("+sldrRed.markerValue+","+ScreenGreen+","+ScreenBlue+")";
                    }
                    else if(colorSlctd==1){
                        cntx.fillStyle="rgb("+ScreenRed+","+sldrGreen.markerValue+","+ScreenBlue+")";
                    }
                    else{
                        cntx.fillStyle="rgb("+ScreenRed+","+ScreenGreen+","+sldrBlue.markerValue+")";
                    }
                }
                else{
                    if(colorSlctd==0){
                        cntx.fillStyle="rgb("+sldrRed.markerValue+",0,0)";
                    }
                    else if(colorSlctd==1){
                        cntx.fillStyle="rgb(0,"+sldrGreen.markerValue+",0)";
                    }
                    else{
                        cntx.fillStyle="rgb(0,0,"+sldrBlue.markerValue+")";
                    }
                    if(i % 2 == 1 || DrawX<PartialColorLEFT || DrawY>=BottomPanelTop || DrawY<TopPanelHeight) drawOK=false;
                }
                if (drawOK) cntx.fillRect(DrawX,DrawY,1,1);                    
            }
        }
    }
}

function DrawScreenColor(){
    cntx.fillStyle="rgb("+ScreenRed+","+ScreenGreen+","+ScreenBlue+")";
    cntx.fillRect(ScreenX,ScreenY,ScreenWIDTH,ScreenHEIGHT);
}

function handleTextBoxEntry(txtBoxID){
    errMsg="";
    var txt=txtBoxID.value();
    if (txt==""){
        errMsg="Πληκτρολόγησε έναν αριθμό μέσα στο λευκό πλαίσιο!";
    }
    else{
        if(!numberOK(txt)){
            txtBoxID.fontColor("#ffffff");
            txtBoxID.backgroundColor("#ff0000");
            errMsg="Καλύτερα να χρησιμοποιήσεις μόνο αριθμητικά ψηφία!";
        }
        else{
            var foreRed=txtBoxID._y==sldrRedTop-20?255:0;
            var foreGreen=txtBoxID._y==sldrGreenTop-20?255:0;
            var foreBlue=txtBoxID._y==sldrBlueTop-20?255:0;
            txtBoxID.fontColor("rgb("+foreRed+","+foreGreen+","+foreBlue+")");
            txtBoxID.backgroundColor("#ffffff");
            var newColor=parseInt(txt);
            if(newColor<0 || newColor>255){
                errMsg="Πληκτρολόγησε έναν ακέραιο αριθμό στο διάστημα [0 , 255]"; 
            }
            else{
                if(greyOn){
                    defineGreyColor(newColor,-1);
                }
                else{
                    if(foreRed==255){
                        Red=newColor;
                        BorderRed=true;
                        sldrRed.setMarkerValue(newColor);
                    }
                    else if(foreGreen==255){
                        Green=newColor;
                        BorderGreen=true;
                        sldrGreen.setMarkerValue(newColor);
                    }
                    else if(foreBlue==255){
                        Blue=newColor;
                        BorderBlue=true;
                        sldrBlue.setMarkerValue(newColor);
                    }
                }
            }
        }
    }
    drawBasicScreen();
}

function numberOK(No){
    var sum=0;
    var flag=No.length==0?false:true;
    var digit;
    if(flag){
        for(var i=0;i<No.length;i++){
            digit=No.charAt(i);
            if(digit<"0" || digit>"9"){
                flag=false;
            }
            else{
                sum=sum+parseInt(digit*Math.pow(10,parseInt(No.length-i-1)));
            }           
        }
    }
    return flag;
}

function drawGreySwitch(){
    if(greySwitchHover){
        cntx.strokeStyle="#0000ff";
        cntx.fillStyle="#ffffff";
    }
    else{
        cntx.strokeStyle="#000000";
        cntx.fillStyle="#e1e1e1";
    }
    cntx.fillRect(greySwitchLeft,greySwitchTop,switchSize,switchSize);
    cntx.beginPath();
    cntx.rect(greySwitchLeft,greySwitchTop,switchSize,switchSize);
    if(greyOn){
        cntx.moveTo(greySwitchLeft+switchSize,greySwitchTop+switchSize);
        cntx.lineTo(greySwitchLeft,greySwitchTop);
        cntx.moveTo(greySwitchLeft+switchSize,greySwitchTop);
        cntx.lineTo(greySwitchLeft,greySwitchTop+switchSize);
    }
    cntx.stroke();
    cnvsWrite(LetterColor,fontSize-2,"Arial",greySwitchLeft+switchSize+captionPadding,greySwitchTop+switchSize,"Κλίμακα του Γκρι");
}